<!DOCTYPE html>
<!-- indique un doc en HTML5-->
<html>

<head>
	<title>JavaScript</title>
	<meta charset="utf-8" /> <!-- aussi par défaut dans HTML5-->
	<link rel="stylesheet" type="text/css" href="../css/Stylesheet.css" />
	<!--va chercher le fichier CSS-->
	<script type="text/javascript" language="javascript"></script>
</head>

<body>
	<Nav>
		<h2 class="navigation flexnav">
			<p><a href="index.html">Balises HTML </a></p>
			<p><a href="TextCSS.html">Mise en forme du texte </a></p>
			<p><a href="Boxmodel.html">Mise en forme des boites </a></p>
			<p><a href="Formulaires.html">Formulaires </a></p>
			<p><a href="JavaScript.html">JavaScript </a></p>
			<p><a href="Illustrations.html">Illustrations </a></p>
		</h2>

	</nav>
	<h1>Introduction à JavaScript</h1><br />
	<p>JS est un langage de programmation objet et événementiel, lié au langage HTML.</p>
	<div>Le code JS est introduit par la balise script <span class="ex">&lt;script&gt; &lt;/script&gt;</span> et peut
		être placé dans :<ul>
			<li>un fichier dédié avec l'extention .js (c'est le mieux, surtout si le fichier HTML est long ou que le
				script sert à plusieurs pages)</li>
			<li>l'élément head, souvent à la fin, pour que le HTML soit lu avant</li>
			<li>l'élément body, souvent à la fin (idem)</li>
			<li>un événement d'un objet de la page.</li>
		</ul>
		Il peut y avoir plusieurs scripts dans une page : ils sont lus et executés dans l'ordre. Il faut toutefois mieux
		les regrouper.</div>
	<p>Chaque instruction se termine par un point-virgule.</p>
	<p>En JS, les commentaires sont écrits dans <span class="ex">/*commentaire mono ou multiligne*/</span> ou après
		<span class="ex">// pour un commentaire monoligne</span>.</p>
	<div class=bord>Sur cette page, pour une meilleure visibilité, le code s'affiche sur un fond gris <span
			class="ex">&lt;script&gt;
			document.write("Bonjour"); &lt;/script&gt;</span> et le résultat d'un code JS s'affichera sur un fond rose :
		<span class="js">
			<script>
				document.write("Bonjour");
			</script>
		</span>
	</div><br />

	<h2>1 - Les variables</h2>
	<div><strong>Une variable JS est un conteneur servant à stocker provisoirement une information.</strong> Cette
		information peut être une valeur (dite primitive) ou un objet (voir plus loin).</p>
		<p>Une variable s'écrit <span class="ex">var</span> suivi du nom de la variable. Chaque variable a un
			<strong>nom
				unique</strong>. Il doit commencer par une lettre. Il peut contenir des chiffres ou les signes _ et $ et
			il est
			sensible à la casse. ATTENTION, <span class="para"><a href="https://www.w3schools.com/js/js_reserved.asp"
					target="_blank">certains
					mots</a> sont réservés </span>(comme "var").
	</div>
	<div>Le signe <span class="ex">=</span> est un signe d'affectation d'une valeur à une variable.<br /><br />
		<span class="ex">&lt;script&gt;<br />
			var x = 25; //la variable x prend la valeur 25<br />
			var X = "Serpentard ?"; //la variable X est différente de la variable x<br />
			var prenom = "Harry" , nom = 'Potter'; //on peut déclarer plusieurs variables, séparées par une
			virgule<br />
			document.write(prenom + " " +nom + ", "+ X); // expected : Harry Potter, Serpentard ?<br />
			&lt;/script&gt;</span><br />
		<script>
			var x = 25; //la variable x prend la valeur 25
			var X = "Serpentard ?"; //la variable X est différente de la variable x
			var prenom = "Harry",
				nom = 'Potter'; //on peut déclarer plusieurs variables, séparées par une virgule
		</script>

		<p>Si on affecte une nouvelle valeur à une variable, elle écrase la précédente.</p>
		<span class="ex">&lt;script&gt;<br />
			var X = "Griffondor"; //nouvelle affectation à X<br />
			&lt;/script&gt;</span>
		<span class="js"><br />
			<script>
				var X = "Griffondor"; //nouvelle affectation à X
				document.write(prenom + " " + nom + ", " + X); // expected : Harry Potter
			</script>
		</span>
	</div>
	<h3>Les types de variables</h3>
	<div>
		<ul>Il existe des valeurs de type :
			<li><strong>number</strong> (tout nombre, entier ou décimaux, positif ou négatif)</li>
			<li><strong>string</strong> (chaine de caractères) qui sera entourée de guillemets ou d'apostrophes
				(ATTENTION: quand la chaine en contient : utiliser un antislash \ (alt maj /) pour la neutraliser ou
				alors &prime; ou &Prime;
				dans le texte (voir <a href="https://www.startyourdev.com/html/html-article-caracteres-html"
					target="_blank">ici</a>
				la liste des caractères spéciaux en HTML). Un nombre entouré de guillemets sera considéré comme une
				chaine.</li>
			<li><strong>boolean</strong> "true" ou "false" (sans guillemets, sinon c'est une chaine)</li>
			<li><strong>null</strong> (non connaissance de la valeur)</li>
			<li><strong>undefined</strong> (ne pas avoir de valeur définie)</li>
			<li><strong>NaN</strong> (not a number) : toutefois, son type est "number" !</li>
		</ul>
	</div>

	<div>On peut tester le type de valeur avec l'opérateur <span class="ex">typeof()</span>.
		<span class="js"><br />
			<script>
				var a = "bonjour",
					b = 4,
					c = true,
					d = null,
					e, f = NaN;
				document.write('Variable a = &Prime;bonjour&Prime; : ' + typeof (a) +
					"<br/> Variable b = 4 : " + typeof (b) +
					/*on met <br/> car affiché dans un contexte HTML; dans une alerte, mettre \n*/
					"<br/> Variable c = true : " + typeof (c) +
					"<br/> Variable d = null : " + typeof (d) +
					"<br/> Variable e = : " + typeof (e) +
					"<br/> Variable f = NaN : " + typeof (f));
			</script>
		</span>
		<p>Une variable peut aussi stocker un array (tableau), un objet, une fonction.</p>
	</div>
	<h3>Le scope d'une variable (notion avancée)</h3>
	<p>Une variable peut avoir une portée (scope) globale (= lisible dans tout le document) ou locale (= lorsqu'elle est
		déclarée dans une fonction, elle n'existe pas en dehors). La déclaration locale doit être prévilégiée pour ne
		pas polluer le code.</p>
	<div>
		<span class="ex">&lt;script&gt;<br />
			var d;
			function multiply(number1, number2) {//crée une fonction<br />
			var resultMultiply = number1 * number2;<br />
			var a = 2;<br />
			b = 3;<br />
			d = 1;<br />
			return resultMultiply;<br />
			}<br />
			var c = 5;<br />
			var result1 = multiply(a,a);// expected = NaN car la var a n'existe plus<br />
			var result2 = multiply(b,b);// = 9 : c'est un moyen de rendre une variable globale<br />
			var result3 = multiply(c,c);// = 25<br />
			var result4 = multiply(d,d);// = 1<br />
			document.write(result1 + ", " + result2 + ", " +result3 + ", " +result4);<br />document.write(a + ", " + b +
			", " +c + ", " +d);<br />
			&lt;/script&gt;</span><br />
		<span class="js">
			<script>
				var d = 0;

				function multiply(number1, number2) { //crée une fonction
					var resultMultiply = number1 * number2;
					var a = 2;
					b = 3;
					d = 1;
					return resultMultiply;
				}
				var c = 5;
				var result1 = multiply(a, a);
				var result2 = multiply(b, b);
				var result3 = multiply(c, c);
				var result4 = multiply(d, d);
				document.write("result = " + result1 + ", " + result2 + ", " + result3 + ", " + result4);
				document.write("<br/> var = " + a + ", " + b + ", " + c + ", " + d);
			</script>
		</span>

		<p>Un moyen de rendre un variable globale est de la déclarer sans le terme "var" (mais c'est une mauvaise
			pratique, car ce n'est pas exactement une variable et complexifie le code). Une autre solution est de la
			déclarer avant la fonction et de lui attribuer (ou lui réattribuer) une valeur dedans (voir l'exemple avec
			var = d).</p>
	</div>

	<h3>let et const sont désormais préférés à var (notion avancée)</h3>
	<p><span class="ex">let</span> est équivalent à var, mais sa portée est limitée au bloc (= ce qu'il y a dans
		l'accolade) dans lequel il est déclaré, tandis que la portée de var est la fonction.</p>

	<div>
		<p><span class="ex">const</span> permet de déclarer une constante (nom en majuscule). Elle a besoin d'une valeur
			intiale.</p>
		<span class="ex">
			const CONFIG;
			// renvoie une erreur car il manque la valeur initiale</span><br /><br />
		Sa portée est celle du bloc (comme let).
		<br /><span class="ex">&lt;script&gt;<br />
			function test() {<br />
			if(2 === 2) {<br />
			const CONFIG = 12;<br />
			console.log(CONFIG); //retourne "12"<br />
			}<br />
			console.log(CONFIG); //retourne "ReferenceError: CONFIG is not defined"<br />
			test();<br />
			}<br />
			&lt;/script&gt;</span><br />
		<span class="js">
			<script>
				function test() {
					if (2 === 2) {
						const CONFIG = 12;
						console.log(CONFIG); //retourne 12
					}
					console.log(CONFIG); //ReferenceError: CONFIG is not defined[
				}
				test();
			</script>
		</span><br />

		<div>Une constante ne peut pas changer de valeur.<br />
			<span class="ex">
				const CONFIG = true;<br />
				CONFIG = false // renvoie une erreur</span><br />
			<p>Toutefois, on peut changer la valeur référencée : par exemple rajouter des valeurs à un tableau déclaré
				comme constante.</p>
			<span class="ex">&lt;script&gt;
				const CONFIG2 = [];<br />
				CONFIG2.push(13);<br />
				console.log(CONFIG2); //retourne [13]<br />
				&lt;/script&gt;</span><br />
			<span class="js">
				<script>
					const CONFIG2 = [];
					CONFIG2.push(13);
					console.log(CONFIG2); //retourne [13]
				</script>
			</span>
		</div>
	</div>
	<hr />

	<h2>2 - Les opérations sur les variables</h2>
	<div>Pour des valeurs de type number, les opérations sont les mêmes qu'en math : addition, soustraction,
		multiplication, division + modulo (= le reste entier d'une division)<br />
		<span class="ex">&lt;script&gt; <br />var y = 10, z = -2;
			y = y + 2; //on ajoute 2 à la valeur y qui stocke maintenant 12 <br />
			y = y / 3; //on divise par 3 la valeur y qui stocke maintenant 4 <br />
			var mult = y * z; //on multiplie 6 par -2 donc mult stocke -12 <br />
			var mod = x % y; //on divise 25 (x est défini ligne 59) par y, il reste 1<br />
			document.write(mod); <br /> &lt;/script&gt;</span><br />
		<span class="js">
			<script>
				var y = 10,
					z = -2;
				y = y + 2; /*on ajoute 2 à la valeur y qui stocke maintenant 12*/
				y = y / 3; /*on divise par 3 la valeur y qui stocke maintenant 4*/
				var mult = y * z; /*on multiplie 6 par -2 donc mult stocke -12*/
				var mod = x % y; /*on divise 25 par y, il reste 1*/
				document.write(mod);
			</script>
		</span>
	</div>
	<div>Les priorités de calcul sont :<ol>
			<li>ce qui est entre parenthèses</li>
			<li>multiplication</li>
			<li>division</li>
			<li>modulo</li>
			<li> addition</li>
			<li> soustraction</li>
		</ol>
		<span class="ex">&lt;script&gt; var x = 5, y =10;
			var priorite = x + y / (4 + z) % 3; /*D'abord : 4 + -2 = 2, puis : y / 2 =5 , puis 5 modulo par 5 = 2, et
			enfin 5 +
			2 = 7*/
			document.write(priorite); &lt;/script&gt;</span><br />
		<span class="js">
			<script>
				var x = 5,
					y = 10;
				var priorite = x + y / (4 + z) %
					3; /*D'abord : 4 + -2 = 2, puis : y / 2 =5 , puis 5 modulo par 5 = 2, et enfin 5 + 2 = 7*/
				document.write(priorite);
			</script>
		</span>
	</div>
	<div>On peut utiliser une écriture simplifiée :<ul>
			<li><span class="ex">x += 2</span> équivaut à <span class="ex">x = x + 2</span></li>
			<li><span class="ex">x -= 3</span> équivaut à <span class="ex">x = x - 3</span></li>
			<li><span class="ex">y *= x</span> équivaut à <span class="ex">y = y * x</span></li>
			<li><span class="ex">y /= 2</span> équivaut à <span class="ex">y = y / 2</span></li>
			<li><span class="ex">y %= x</span> équivaut à <span class="ex">y = y % x</span></li>
		</ul>
	</div>
	<div>ATTENTION : le signe + est utilisé aussi pour la concaténation. Dès que le + apparait après une chaine, il
		n'additionne plus, il concatène.
		<span class="ex">&lt;script&gt;
			var x = 1 + 2 + 3 + "4";
			var y = "1" + 2 + 3 + 4;
			var z = 1 + 2 + "trois" + 4;
			document.write("Variable x : " + x + ". Variable y : " + y + ". Variable z : " + z); &lt;/script&gt;</span>
		<br />
		<span class="js">
			<script>
				var x = 1 + 2 + 3 + "4";
				var y = "1" + 2 + 3 + 4;
				var z = 1 + 2 + "trois" + 4;
				document.write("Variable x : " + x + ". Variable y : " + y + ". Variable z : " + z);
			</script>
		</span>
	</div>
	<div>Il existe aussi les opérations incrémentation <span class="ex">++</span> et décrémentation <span
			class="ex">--</span>.
		Ces signes peuvent être placés avant la variable (pre) ou après (post). Les résultats seront différents :<ul>
			<li>Post Increment : var++<br />
				<span class="ex">&lt;script&gt; var a = 0, b = 10; a = b++;
					document.write("Post Increment a = b++ : a = " + a + " b = " + b); &lt;/script&gt;</span><br />
				<span class="js">
					<script>
						var a = 0,
							b = 10;
						a = b++;
						document.write("Post Increment a = b++ : a = " + a + " b = " + b);
					</script>
				</span></li>
			<li>Pre Increment : ++var<br />
				<span class="ex">&lt;script&gt; var a = 0, b = 10; a = ++b;
					document.write("Pre Increment a = ++b : a = " + a + " b = " + b); &lt;/script&gt;</span><br />
				<span class="js">
					<script>
						var a = 0,
							b = 10;
						a = ++b;
						document.write("Pre Increment a = ++b : a = " + a + " b = " + b);
					</script>
				</span></li>
			<li>Post Decrement : var--<br />
				<span class="ex">&lt;script&gt; var a = 0, b = 10; a = b--;
					document.write("Post Decrement a = b-- : a = " + a + " b = " + b); &lt;/script&gt;</span><br />
				<span class="js">
					<script>
						var a = 0,
							b = 10;
						a = b--;
						document.write("Post Decrement a = b-- : a = " + a + " b = " + b);
					</script>
				</span></li>
			<li>Pre Decrement : --var<br />
				<span class="ex">&lt;script&gt; var a = 0, b = 10; a = --b;
					document.write("Pre Decrement a = --b : a = " + a + " b = " + b); &lt;/script&gt;</span><br />
				<span class="js">
					<script>
						var a = 0,
							b = 10;
						a = --b;
						document.write("Pre Decrement a = --b : a = " + a + " b = " + b);
					</script>
				</span></li>
		</ul>
	</div>
	<hr />
	<h2>3 - Les comparaisons</h2>
	<div>Elle se font à l'aide de comparateurs : <ul>
			<li><span class="ex">==</span> est un signe d'équivalence : "est égal à" (en valeur, cad "4" == 4 est vrai)
			</li>
			<li><span class="ex">!=</span> signifie "est différent de" (valeur)</li>
			<li><span class="ex">===</span> signifie "est égal à" (en valeur et en type cad "4" === 4 est faux)</li>
			<li><span class="ex">!==</span> signifie "est différent de " (en valeur et en type)</li>
			<li><span class="ex">
				</span> signifie "est strictement inférieur à" </li>
			<li><span class="ex">></span> signifie "est strictement
				supérieur à"</li>
			<li><span class="ex">
					&lt;=</span> signifie "est inférieur ou égal à" </li>
			<li><span class="ex">>=</span> signifie "est supérieur ou égal
				à"</li>
		</ul>
		Toute comparaison renvoie un boléen : true ou false.</div>
	<hr />
	<h2>4 - Conditions et switch</h2>
	<h3>La condition if</h3>
	<div>La condition <strong>if</strong> est utilisée pour tester si une valeur correspond à un critère, puis exécuter
		un
		bloc de code si c'est vrai<br />
		<span class="ex">&lt;script&gt; var heure = 15; if (heure &lt;= 18==true) {document.write("Bonjour");}
			&lt;/script&gt; </span>
		<span class="js">
			<script>
				var heure = 15;
				if (heure <= 18 == true) {
					document.write("Bonjour");
				}
			</script>
		</span> <br />
	</div>
	<p>Exemple si c'est faux<br />
		<span class="ex">&lt;script&gt; var heure = 21; if (heure &lt;= 18==true) {document.write("Bonjour");}
			&lt;/script&gt; </span>
		<span class="js">
			<script>
				var heure = 21;
				if (heure <= 18 == true) {
					document.write("Bonjour");
				}
			</script>
		</span>
	</p>
	<h3>La condition if...else</h3>
	<div>La condition <strong>if...else</strong> sert pour exécuter un bloc de code si c'est vrai et exécuter un autre
		bloc si c'est faux<br />
		<span class="ex">&lt;script&gt; var heure = 15; if (heure &lt;= 18==true) {document.write("Bonjour");} else
			{document.write("bonsoir");} &lt;/script&gt; </span> <span class="js">
			<script>
				var heure = 15;
				if (heure <= 18 == true) {
					document.write("Bonjour");
				} else {
					document.write("bonsoir");
				}
			</script>
		</span>
	</div>
	<div>Exemple si c'est faux
		<span class="ex">&lt;script&gt; var heure = 21; if (heure &lt;= 18==true) {document.write("Bonjour");} else
			{document.write("bonsoir");} &lt;/script&gt; </span> <span class="js">
			<script>
				var heure = 21;
				if (heure <= 18 == true) {
					document.write("Bonjour");
				} else {
					document.write("Bonsoir");
				}
			</script>
		</span>
	</div>
	<h3>La condition if...else If...else</h3>
	<p>La condition <strong>if...else if...else </strong> pour gérer autant de cas que l'on veut. ATTENTION, l'ordre
		dans
		lequel les conditions sont écrites est important.</p>
	<p>S'il s'agit de formulaires, il faut prévoir les cas où les gens entrent des données aberrantes.</p>
	<p>L'écriture <strong> == true </strong> est facultative car la comparaison à vrai est implicite. On peut toutefois
		également tester "== false". Toute valeur différente de null, undefined, NaN, 0 et "" est évaluée par défaut à
		true.</p>
	<div>L'écriture ternaire permet encore de simplifier les conditions, selon le schéma : <br /><strong>variable =
			(condition) ? valeurvrai : valeurfaux;</strong><br />
		<span class="ex">&lt;script&gt; var heure = 15, bon="";
			bon = (heure &lt;= 18) ? "Bonjour" : "Bonsoir" ; document.write(bon); &lt;/script&gt; </span> <span
			class="js">
			<script>
				var heure = 15,
					bon = "";
				bon = (heure <= 18) ? "Bonjour" : "Bonsoir";
				document.write(bon);
			</script>
		</span>
	</div>
	<div>Un autre exemple : <br />
		<span class="ex">&lt;script&gt; var age = 16; var ismajeur = (age &lt; 18) ? "trop jeune" : "assez vieux" ;
			document.write(ismajeur); &lt;/script&gt; </span> <span class="js">
			<script>
				var age = 16;
				var ismajeur = (age < 18) ? "trop jeune" : "assez vieux";
				document.write(ismajeur);
			</script>
		</span>
	</div>
	<h3>Le switch</h3>
	<div>Il peut être utilisé quand il y a beaucoup de cas à la place d'un if...else, mais ATTENTION : il ne teste que
		les
		égalités. Dans un switch, il faut créer des cas, appelés <span class="ex">case </span>. Le mot clé <span
			class="ex">break</span>
		permet d'arrêter la boucle et de sortir du switch (sinon, le switch va lire et exécuter chaque cas). Le break
		doit
		être écrit après chaque cas. A la fin, il faut créer un cas par défaut, pour des valeurs non prises en charges
		dans
		les cas. <br />
		<span class="ex">&lt;script&gt; var jour = "j"; switch (jour) {
			case "l" : document.write("lundi"); break;
			case "ma" : document.write("mardi"); break;
			case "me" : document.write("mercredi"); break;
			case "j" : document.write("jeudi"); break;
			case "v" : document.write("vendredi"); break;
			case "s" : document.write("samedi"); break;
			case "d" : document.write("dimanche"); break;
			default : document.write("quel jour?");
			} &lt;/script&gt;</span>
		<span class="js">
			<script>
				var jour = "j";
				switch (jour) {
					case "l":
						document.write("lundi");
						break;
					case "ma":
						document.write("mardi");
						break;
					case "me":
						document.write("mercredi");
						break;
					case "j":
						document.write("jeudi");
						break;
					case "v":
						document.write("vendredi");
						break;
					case "s":
						document.write("samedi");
						break;
					case "d":
						document.write("dimanche");
						break;
					default:
						document.write("quel jour?");
				}
			</script>
		</span>
	</div>
	<hr />
	<h2>5 - Les opérateurs logiques</h2>
	<div>Il existe 3 opérateurs très utilisés en JS : <ul>
			<li>AND (&&)<br />
				<span class="ex">&lt;script&gt; var heure = 12; if (heure >= 0 && heure &lt; 12) {document.write ("C'est
					le
					matin");}
					else if (heure===12) {document.write ("Il est midi");} else if (heure> 12 && heure &lt;= 18)
					{document.write
					("c'est
					l'après-midi");} else if (heure> 18 && heure &lt;= 24) {document.write ("C'est le soir");} else
					{document.write("donnée non valide");} &lt;/script&gt; </span> <span class="js">
					<script>
						var heure = 12;
						if (heure >= 0 && heure < 12) {
							document.write("C'est le matin");
						} else if (heure === 12) {
							document.write("Il est midi");
						} else if (heure > 12 && heure <= 18) {
							document.write("c'est l'après-midi");
						} else if (heure > 18 && heure <= 24) {
							document.write("C'est le soir");
						} else {
							document.write("donnée non valide");
						}
					</script>
				</span></li>
			<li>OR (||) alt maj l<br />
				<span class="ex">&lt;script&gt; var heure = 8; if (heure &lt; 0 || heure> 24) {document.write ("Donnée
					invalide");}
					else {document.write("Il est "+ heure + "h");} &lt;/script&gt;</span>
				<span class="js">
					<script>
						var heure = 8;
						if (heure < 0 || heure > 24) {
							document.write("Donnée invalide");
						} else {
							document.write("Il est " + heure + "h");
						}
					</script>
				</span></li>
			<li>NOT (!) : Un exemple avec ! (à faire)<br /><span class="ex">&lt;script&gt; document.write("exemple");
					&lt;/script&gt;</span>
				<span class="js">
					<script>
						document.write("exemple");
					</script>
				</span></li>
		</ul>
	</div>
	<hr />
	<h2>6. Les boucles (loop)</h2>
	<div>Pour exécuter un bloc de code plusieurs fois, tant qu'une condition est remplie (automatise la répétition).
		Mais
		elle doit toujours être fausse à un moment pour arrêter la boucle.<ul>


			<li>6.1. forEach() examine chaque cas du tableau. A utiliser en priorité si possible car évite de manipuler
				les i.
				<span class="ex">&lt;script&gt;<br /> let tab = ["A", "B", "C"];
					for (i = 0; i &lt; 10; i++) { <br />document.write("i contient la valeur : " + i + " .
					");} <br />&lt;/script&gt;</span>
				<span class=" js">
					<script>
						var i;
						for (i = 0; i < 10; i++) {
							document.write("i contient la valeur : " + i + ". ");
						}
					</script>
				</span></li>
			<li>6.2. la boucle for : pour répéter une série d'instruction à partir d'une valeur donnée jusqu'à une autre
				valeur
				(valeur initiale, incrémentation, obitération).
				<span class="ex">&lt;script&gt;<br /> var i;
					for (i = 0; i &lt; 10; i++) { <br />document.write("i contient la valeur : " + i + " .
					");} <br />&lt;/script&gt;</span>
				<span class=" js">
					<script>
						var i;
						for (i = 0; i < 10; i++) {
							document.write("i contient la valeur : " + i + ". ");
						}
					</script>
				</span></li>

			<li>6.3. la boucle while : pour répéter une série d'instruction tant qu'une condition est vraie
				<span class="ex">&lt;script&gt; var x = 0;<br />
					while (x &lt; 10) {document.write("x contient la valeur : " + x + " .
					");
					x++;} &lt;/script&gt;</span>
				<span class=" js">
					<script>
						var x = 0;
						while (x < 10) {
							document.write("x contient la valeur : " + x + ". ");
							x++;
						}
					</script>
				</span><br />
				ATTENTION : si l'incrémentation se fait avec le double signe avant la variable (++x), elle sera
				prioritaire.</li>

			<li>6.4. la boucle do...while : même chose, mais on exécute la boucle au moins une fois</li>
			<span class="ex">&lt;script&gt; var x = 100;
				do {document.write("x contient la valeur : " + x + ". ");}
				while (x &lt; 10) &lt;/script&gt; </span> <span class="js">
				<script>
					var x = 100;
					do {
						document.write("x contient la valeur : " + x + ". ");
					} while (x < 10)
				</script>
			</span><br />
			<span class="ex">&lt;script&gt; var x = 100; while (x &lt; 10 {document.write("x contient la valeur : " + x
				+ " .
				");}) &lt;/script&gt;</span><br />
			<span class=" js">
				<script>
					var x = 100;
					while (x < 10) {
						document.write("x contient la valeur : " + x + ". ");
					}
				</script>
			</span>
		</ul>
	</div>

	<hr />
	<h2>7 - Les fonctions</h2>
	<p>C'est un bloc de code qui doit effectuer une tâche précise avec les parametres qu'on lui donne et qui va renvoyer
		le résultat avec le mot clé <span class="ex">return</span>. Il y a des fonctions natives (déjà créées par
		d'autres,
		par exemple <span class="ex">alert()</span>, que l'on appelle "methodes" <a
			href="https://developer.mozilla.org/fr/docs/Web/JavaScript/Reference/Index_des_m%C3%A9thodes"
			target="_blank">(voir ici)</a> et les fonctions qu'on va créer nous mêmes.</p>
	<p>Pour créer une fonction, il faut utiliser le mot clé <span class="ex">function</span>. Une fois créée, on peut
		l'utiliser (= l'appeler) autant qu'on veut.</p>
	<p><span class="ex">function nom_de_la_fonction(parametre1, parametre2) {//création de la fonction<br />
			code à exécuter;<br />
			return;//termine la fonction et renvoie le résultat<br />
			}<br />
			var x = 4, y = 5;<br />
			nom_de_la_fonction(x, y);//appel de la fonction avec les valeurs x et y</span></p>
	<div>Exemple de fonction : factorielle de z
		<br /><span class="ex">&lt;script&gt;
			function factorielle(z) {//crée la fonction<br />
			var resultFact = 1; //crée la variable de resultat<br />
			for (var i = 1; i &lt;= z; i++)//incremente<br />
			resultFact = resultFact * i;<br />
			return resultFact;<br />
			}
			document.write(factorielle(5)); &lt;/script&gt;</span>
		<span class="js">
			<script>
				function factorielle(z) {
					var resultFact = 1;
					for (var i = 1; i <= z; i++)
						resultFact = resultFact * i;
					return resultFact;
				}
				document.write(factorielle(5));
			</script>
		</span>
	</div>
	<p>L’instruction <strong>return</strong> renvoie le résultat d'une fonction sans l'afficher. Elle met également fin
		à l’exécution d’une fonction, ce qui signifie que toutes les autres opérations qui suivraient un return dans une
		fonction seront ignorées.</p>

	<h3>Les fonctions récursives (notion avancée)</h3>
	<div>C'est une fonction qui s'appelle elle-même. Une récursion est semblable à une boucle : elles exécutent le même
		code plusieurs fois et s'appuient sur une condition (afin d'éviter une boucle infinie, ou une récursion infinie
		ici). Il y a 3 moyens de faire : <br />

		<span class="ex">var maVariable = function maFonction() {<br />
			// instructions<br />
			};</span>
		<ol>
			<li>maVariable();</li>
			<li>maFonction()</li>
			<li>arguments.callee <a
					href="https://developer.mozilla.org/fr/docs/Web/JavaScript/Reference/Fonctions/arguments/callee"
					target="_blank">((à proscrire, voir ici pourquoi)</a> </li>
		</ol>
		<span class="ex">&lt;script&gt;<br />
			function factorial(z) {//création de la fonction<br />
			if (z === 0)//condition de sortie<br />
			return 1; //exécute et stoppe<br />
			else return z * factorial(z - 1);//appel récursif<br />
			}<br />
			factorial(5); //appel de la fonction<br />
			document.write(factorial(5));<br />
			&lt;/script&gt;</span>
		<span class="js">
			<script>
				function factorial(z) { //création de la fonction
					if (z === 0) //condition de sortie
						return 1; //exécute et stoppe
					else return z * factorial(z - 1); //appel récursif
				}
				factorial(5); //appel de la fonction
				document.write(factorial(5));
			</script>
	</div>

	<h3>Les fonctions anonymes (notion avancée)</h3>
	<div>On ne donne pas de nom à la fonction. Elle est stockée dans une variable. Elle sera appelée par le biais de la
		variable. <a href="http://sametmax.com/la-fonction-anonyme-appelee-immediatement-en-javascript-function/"
			target="_blank">(voir ici pour plus d'infos)</a>
		<br />
		<span class="ex">&lt;script&gt; <br />
			var carre = function(x) { <br />
			document.write("Carré de " + x + " = " + x*x); <br />
			}; <br />
			var y = 5; <br />
			carre(y); <br />
			&lt;/script&gt;</span>

		<span class="js">
			<script>
				var carre = function (x) {
					document.write("Carré de " + x + " = " + x * x);
				};
				var y = 5;
				carre(y);
			</script>
		</span>
	</div>
	
	<h3>Les fonctions auto-imbriquées (notion avancée)</h3>
	<div>Ce sont des fonctions qui vont s’appeler elles-mêmes. Pour créer une fonction auto-invoquée à partir d'une
		fonction, il va tout simplement falloir rajouter un couple de parenthèses autour de la fonction et un second
		après le code de la fonction. En général, ce système d’auto-invocation est utilisé avec les fonctions anonymes,
		car cela constitue un autre bon moyen de les exécuter.<br />
		<span class="ex">&lt;script&gt; <br />
			(function(x) { <br />
			x = 7; <br />
			document.write("Cube de " + x + " = " + x*x*x); <br />
			})(); <br />
			&lt;/script&gt;</span>

		<span class="js">
			<script>
				(function (x) {
					x = 6;
					document.write("Cube de " + x + " = " + x * x * x);
				})();
			</script>

	</div>

	<h3>Les closures (notion avancée)</h3>
	<div>Une closure (de « close », « fermé » en anglais) est une fonction qui va récupérer et pouvoir utiliser des
		variables d’environnement dans laquelle elle a été créée. Autrement dit, ces fonctions se « souviennent » de
		l'environnement dans lequel elles ont été créées (on dit aussi que la fonction capture son « environnement »).
		On peut utiliser la valeur de i plusieurs fois en dehors de la fonction. Pourtant i est protégé car ne peut pas
		être modifié par l'environnement extérieur.

		<span class="ex">&lt;script&gt; <br />
			function compteur1(){ <br />
			var i = 0; <br />
			return function() { //fonction anonyme qui a accès à i défini dans son parent (normal!)<br />
			return i++; <br />
			} <br />
			} <br />
			var compt1 = compteur1();//stocke la fonction compteur1 = une closure<br />
			var compt2 = compteur1();//stocke la fonction compteur1 indépendant du premier<br />
			document.write("premier tour de compt1 : " + compt1() + <br />
			"deuxième tour de compt1 : " + compt1() + <br />
			"troisième tour de compt1 : " + compt1() + <br />
			"premier tour de compt2 : " + compt2());<br />
			<br />
			&lt;/script&gt;</span><br />

		<span class="js">
			<script>
				function compteur1() {
					var i = 0;
					return function () {
						return i++;
					}
				}
				var compt1 = compteur1(); //stocke la fonction compteur1
				var compt2 = compteur1(); //seconde variable qui stocke compteur1
				document.write("premier tour de compt1 : " + compt1() +
					"<br/> deuxième tour de compt1 : " + compt1() +
					"<br/> troisième tour de compt1 : " + compt1() +
					"<br/> premier tour de compt2 : " + compt2());
			</script>
		</span>

		<h3>Les callback (notion avancée)</h3>
		<div> explication d'un callback et exlication de la fonction qui va suivre. <br />
				
					<p class="js">Cliquez sur les "P" et regardez le résultat dans la console</p>	
					<p class="callname js">P1</p>
					<p class="callname js">P2</p>
					<p class="callname js">P3</p>

		<span class="ex">&lt;script&gt;<br />
			var elements = document.getElementsByClassName("callname");<br />

			for (var i = 0 ; i < elements.length ; i++) {<br />
				  elements[i].addEventListener('click', (function(local_cpt) {<br />
					return function() {<br />
						  document.write(elements[local_cpt].innerText);<br />
					}<br />
				  })  (i)  );<br />
			  }<br />
			  &lt;/script&gt;</span><br />
		<span class="js">
			<script>
				var elements = document.getElementsByClassName("callname");

				for (var i = 0 ; i < elements.length ; i++) {
  					elements[i].addEventListener('click', (function(local_cpt) {
    					return function() {
      						console.log(elements[local_cpt].innerText);
    					}
  					})  (i)  );
  				}
			</script>

		</div>
		<br />
		<hr />
		<h2>8 - Les objets</h2>
		<p>Un objet est un ensemble structuré de différentes propriétés et de fonctionnalités (appelées méthodes). Un
			objet
			peut être une chaine de caractères (= "string"), un nombre, un booléen, une fonction, un tableau... Sa
			syntaxe :
			<span class="ex"><br />var objectName = {<br />
				propertyName1:propertyValue1;<br />propertyName2:propertyValue2;<br />method1:function();<br />
				};
			</span></p>
		<p><strong>Les propriétés</strong> peuvent être assimilées à des variables, qui contiendraient plusieurs
			valeurs.
			C'est une liste de valeurs qui s'écrivent par paires, comme ceci : <span class="ex">nom : valeur</span>.</p>
		<p>Exemple : <span class="ex">var personne1 = {nom:"Trotro", prenom: "Anne"; age : 50; couleur:"vert"};</span>.
			Cet
			objet "personne1" contient 4 propriétés, qui ont chacune une valeur.</p>
		<p>On peut accéder aux propriétés d'un objet de deux manières : <span class="ex">objectName.propertyName1</span>
			ou
			<span class="ex">objectName["propertyName2"]</span>. <br />Dans notre exemple, pour récupérer l'âge : <span
				class="ex">var
				X = personne1.age</span> ou <span class="ex">var Y = personne1["age"]</span>.</p>
		<p><strong>La méthode</strong> d'un objet est une propriété qui contient une fonction (ce à quoi l'objet peut
			servir).
			On accède à une méthode par la syntaxe : <span class="ex">objectName.methodName()</span>. Les méthodes sont
			stockées comme les propriétés de l'objet.</p>
		<p>Par exemple, pour <span class="ex">document.write()</span>, la fonction <span class="ex">write()</span> est
			une
			méthode de l'objet <span class="ex">document</span>.</p>
		<p>Il existe des objets "natifs" prêt à l'emploi : string, number, bolean, array (qui gère les tableaux)... ou
			on
			peut
			créer nos propres objets (comme l'objet "personne1" ci-dessus). On peut aussi vouloir créer un objet-type
			qui
			sera
			comme un modèle pour créer d'autres objets. Pour cela on utilise un <strong>constructeur</strong> avec la
			syntaxe
			<span class="ex">function</span>.</p>

		<div>Dans l'exemple ci-dessous, la fonction "personne" est un objet constructeur qui prend les paramètres et
			leur
			assigne les propriétés de l'objet. Le mot clé <span class="ex">this</span> renvoie à l'objet en cours. Ce
			n'est
			pas
			une variable et sa valeur ne peut pas être changée. En utilisant ensuite le mot clé <span
				class="ex">new</span>,
			on
			peut créer des objets sur le même modèle.<br />
			<span class="ex"> &lt;script&gt; /*le constructeur*/function personne(nom, prenom, age, couleur) {this.nom =
				nom;
				this.prenom = prenom; this.age = age; this.couleur = couleur;}<br /> /*la création des objets*/var p1 =
				new
				personne("Potter", "Harry", 42, "rouge");<br />var p2 = new personne("Response", "Alice", 19,
				"or")<br />
				/*le
				retour*/document.write(p2.nom); document.write(p1.age); &lt;/script&gt; </span></p>
			<span class="js">
				<script>
					/*le constructeur*/
					function personne(nom, prenom, age, couleur) {
						this.nom = nom;
						this.prenom = prenom;
						this.age = age;
						this.couleur = couleur;
					}
					/*la création des objets*/
					var p1 = new personne("Potter", "Harry", 42, "rouge");
					var p2 = new personne("Response", "Alice", 19, "or")
					/*le retour*/
					document.write(p2.nom);
					document.write(p1.age);
				</script>
			</span>
		</div>
		<div>Autre exemple<br /><span class="ex">&lt;script&gt; function person(name, age) {this.name=name;
				this.age=age;this.yearOfBirth= bornYear;}
				function bornYear() {return 2018- this.age;}
				var p = new person("Olivier",51);
				document.write(p.yearOfBirth()); &lt;/script&gt;</span>
			<span class="js">
				<script>
					function person(name, age) {
						this.name = name;
						this.age = age;
						this.yearOfBirth = bornYear;
					}

					function bornYear() {
						return 2019 - this.age;
					}
					var p = new person("Harry", 37);
					document.write(p.yearOfBirth());
				</script>
			</span>
		</div>

		<h3>L'objet String</h3>
		<div>Il sert à gérer les chaines de caractères en JS. Il faut mieux utiliser les valeurs primitives plutot que
			créer
			un nouvel objet string à partir de sa fonction constructeur. Il possède 3 propriétés : <ul>
				<li>length : pour compter le nombre de caractères de la chaine <br /><span class="ex">&lt;script&gt; var
						sorcier =
						{nom: "TOM ELVIS JEDUSOR", maison: "Serpentard"}; document.write(sorcier.nom.length);
						&lt;/script&gt;</span>
					<span class="js">
						<script>
							var sorcier = {
								nom: "TOM ELVIS JEDUSOR",
								maison: "Serpentard"
							};
							document.write(sorcier.nom.length);
						</script>
					</span></li>
				<li>prototype : pour ajouter de nouvelles propriétés ou méthodes à un objet (peu utilisé)</li>
				<li>constructor : va retourner la fonction qui a créé le prototype de l'objet (peu utilisé)</li>
			</ul>et une vingtaine de méthodes : <ul>
				<li>toLowerCase() : mettre en minuscules</li>
				<li>toUpperCase() : mettre en majuscules <br /><span class="ex">&lt;script&gt; var texte = "J'apprends
						le
						JavaScript."; var maj = texte.toUpperCase(); document.write(maj); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var texte = "J'apprends le JavaScript.";
							var maj = texte.toUpperCase();
							document.write(maj);
						</script>
					</span></li>
				<li>charAt() retourne le caractère situé à une position donnée (ATTENTION, le premier caractère de la
					chaine
					a la
					position 0). L'exemple ci-dessous utilise la boucle "for" et l'objet "array":<br /><span
						class="ex">&lt;script&gt;
						var texte = "TOM ELVIS JEDUSOR"; var nom = [texte.charAt(10),
						texte.charAt(11),
						texte.charAt(3),
						texte.charAt(8),
						texte.charAt(13),
						texte.charAt(7),
						texte.charAt(14),
						texte.charAt(9),
						texte.charAt(6),
						texte.charAt(1),
						texte.charAt(5),
						texte.charAt(12),
						texte.charAt(11),
						texte.charAt(2),
						texte.charAt(15),
						texte.charAt(16),
						texte.charAt(0)], sorcier = ""; for (var i = 0; i &lt;nom.length; i++) {sorcier += nom[i];};
						document.write(sorcier); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var texte = "TOM ELVIS JEDUSOR";
							var nom = [texte.charAt(10),
									texte.charAt(11),
									texte.charAt(3),
									texte.charAt(8),
									texte.charAt(13),
									texte.charAt(7),
									texte.charAt(14),
									texte.charAt(9),
									texte.charAt(6),
									texte.charAt(1),
									texte.charAt(5),
									texte.charAt(12),
									texte.charAt(11),
									texte.charAt(2),
									texte.charAt(15),
									texte.charAt(16),
									texte.charAt(0)
								],
								sorcier = "";
							for (var i = 0; i < nom.length; i++) {
								sorcier += nom[i];
							};
							document.write(sorcier);
						</script>
					</span></li>
				<li>indexOf() : retourne la première position à laquelle un (ou plusieurs) caractères ont été trouvés =
					première
					occurrence. On peut aussi préciser la position où on veut démarrer la recherche (seconde valeur)
				</li>
				<li>lastIndexOf() : dernière occurrence</li>
				<li>replace() : remplacer un caractère par un autre.</li>
				<li>slice() : pour extraire une partie d'une chaine.</li>
				<li>trim() : supprime les espaces superflus en début et fin de chaine</li>
				<li>valueOf() : retourne la valeur primitive d'un objet de type string</li>
				<li>search() et match() : vont comparer une chaine à une certaine expression et vont retourner la
					correspondance</li>
				<li>split() : va casser une chaine de caractères selon un délimiteur et va créer un tableau avec les
					morceaux</li>
			</ul>
		</div>

		<h3>L'objet Number</h3>
		<div>Il sert à gérer les nombres en JS. Il faut mieux utiliser les valeurs primitives plutot que créer un nouvel
			objet
			number à partir de sa fonction constructeur. L'objet Number possède 5 propriétés exclusives :<ul>
				<li>MIN_VALUE et MAX_VALUE : vont respectivement retourner le plus petit et le plus grand nombre
					possible en
					JS <br /><span class="ex">&lt;script&gt; var min = Number.MIN_VALUE; var max = Number.MAX_VALUE;
						document.write("Valeur minimum en JS = "+min+ " et valeur maximum en JS = " + max);
						&lt;/script&gt;</span>
					<span class="js">
						<script>
							var min = Number.MIN_VALUE;
							var max = Number.MAX_VALUE;
							document.write("Valeur minimum en JS = " + min + " et valeur maximum en JS = " + max);
						</script>
					</span></li>
				<li>NEGATIVE_INFINITY et POSITIVE_INFINITY : représentent l'infini négatif et positif</li>
				<li>NaN : représente une valeur qui n'est pas un nombre. <br /><span class="ex">&lt;script&gt; var
						chuispa1nombre =
						Number.NaN;
						document.write("chuispa1nombre = "+chuispa1nombre); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var chuispa1nombre = Number.NaN;
							document.write("chuispa1nombre = " + chuispa1nombre);
						</script>
					</span></li>
			</ul>
		</div>
		<div>L'objet Number compte une dizaines de méthodes, parmi on trouve : <ul>
				<li>toString() : va transformer un nombre en chaine de caractère
					<br /><span class="ex">&lt;script&gt; var x = 12; var y = x.toString();
						document.write("Type de x = "+ typeof(x) + " et type de y = " + typeof(y));
						&lt;/script&gt;</span>
					<span class="js">
						<script>
							var x = 12;
							var y = x.toString();
							document.write("Type de x = " + typeof (x) + " et type de y = " + typeof (y));
						</script>
					</span></li>
				<li>toFixed() : va changer un nombre en chaine de caractère en ne gardant que le nombre de décimale que
					l'on
					veut
					<br /><span class="ex">&lt;script&gt; var x = Math.PI; var y = x.toFixed(4);
						document.write("Valeur de y = "+y+ " et type de y = "+typeof(y)); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var x = Math.PI;
							var y = x.toFixed(4);
							document.write("Valeur de y = " + y + " et type de y = " + typeof (y));
						</script>
					</span></li>
				<li>toPrecision() : va changer un nombre en chaine de caractère en ne gardant que le nombre de chiffres
					que
					l'on
					veut (poser les valeurs 5, 4 et 3 pour voir)<br /><span class="ex">&lt;script&gt; var x = 1234.5678;
						var
						y =
						x.toPrecision(3);
						document.write("Valeur de y = "+y+ " et type de y = "+typeof(y)); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var x = 1234.5678;
							var y = x.toPrecision(3);
							document.write("Valeur de y = " + y + " et type de y = " + typeof (y));
						</script>
					</span></li>
				<li>toExponential() : va choisir le nombre de décimales d'un nombre et va le retourner sous forme de
					chaine
					en
					utilisant une notation exponentielle</li>
				<li>la méthode globale Number() : va convertir certaines valeurs JS (booléens, dates...) en
					nombres.<br /><span class="ex">&lt;script&gt; var vrai = true; var faux = false; var d = new Date();
						document.write("true renvoie : "+Number(vrai)+ " ; false renvoie : "+Number(faux)+ " ; date
						renvoie
						: "+Number(d)+
						" (c'est le timestamp en ms"); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var vrai = true;
							var faux = false;
							var d = new Date();
							document.write("true renvoie : " + Number(vrai) + " ; false renvoie : " + Number(faux) + " ; date renvoie : " +
								Number(d) + " (c'est le timestamp en ms");
						</script>
					</span></li>
				<li>la méthode globale <span class="ex">parseInt()</span> va renvoyer un nombre entier à partir d'une
					chaine
					de
					caractère et la méthode globale <span class="ex">parseFloat()</span> va renvoyer un nombre entier ou
					décimal à
					partir d'une chaine de caractère <br /><span class="ex">&lt;script&gt; var x = 1234.5678; var entier
						=
						parseInt(x);
						var decimal = parseFloat(x);
						document.write("avec parseInt : "+entier+ " ; avec parseFloat : "+decimal);
						&lt;/script&gt;</span>
					<span class="js">
						<script>
							var x = 1234.5678;
							var entier = parseInt(x);
							var decimal = parseFloat(x);
							document.write("avec parseInt : " + entier + " ; avec parseFloat : " + decimal)
						</script>
					</span></li>
			</ul>
		</div>
		<h3>L'objet Array</h3>
		<div>Un tableau ("array") est un type de variable spécial qui peut stocker plusieurs valeurs. Par exemple 3
			variables
			peuvent être contenues dans seul un tableau. Dans ce cas un index numérique unique est créé et affecté à
			chaque
			élément du tableau. Le premier élément aura l'index "0", le deuxième, l'index "1"... Pour retrouver, ou
			changer
			un
			élément, on utilise l'index. Appeler un objet inexistant renvoie "undefined".<br />
			<span class="ex">var fruit1 = "abricot";<br />
				var fruit2 = "banane";<br />
				var fruit3 = "cerise";</span> devient <br />
			<span class="ex">&lt;script&gt; var fruits = new Array("abricot", "banane", "citron");
				fruits[2]= "cerise"; fruits[4]="épine-vinette";
				document.write(fruits[1] + " " + fruits[2] + " " + fruits[5]); document.write(fruits);
				&lt;/script&gt;</span>
			<span class="js">
				<script>
					var fruits = new Array("abricot", "banane", "citron");
					fruits[2] = "cerise";
					fruits[4] = "épine-vinette";
					document.write(fruits[1] + " " + fruits[2] + " " + fruits[5]);
					document.write(fruits);
				</script>
			</span>
		</div>
		<div>On peut aussi utiliser une écriture simplifiée avec des crochets :<br />
			<span class="ex">&lt;script&gt; var fruits = ["abricot", "banane", "cerise", "datte"];
				document.write(fruits.length); &lt;/script&gt;</span>
			<span class="js">
				<script>
					var fruits = ["abricot", "banane", "cerise", "datte"];
					document.write(fruits.length);
				</script>
			</span>
		</div>

		<div>ATTENTION, JavaScript n'accepte pas les index avec des noms (appelés "associative arrays"). Dans ce cas, le
			tableau est traité comme un objet et les méthodes et propriétés de l'objet "array" seront incorrects.<br />
			<span class="ex">&lt;script&gt; var fruits = [];
				fruits["fruit1"]="abricot";fruits["fruit0"]="abricot";fruits["fruit1"]="banane";fruits["fruit2"]="cerise";fruits["fruit3"]="datte";
				document.write(fruits.length); &lt;/script&gt;</span>
			<span class="js">
				<script>
					var fruits = [];
					fruits["fruit1"] = "abricot";
					fruits["fruit0"] = "abricot";
					fruits["fruit1"] = "banane";
					fruits["fruit2"] = "cerise";
					fruits["fruit3"] = "datte";
					document.write(fruits.length);
				</script>
			</span>
		</div>

		<div>La propriété <span class="ex">length</span> peut permettre de rajouter des éléments à notre tableau. Comme
			le
			premier élément du tableau est numéroté 0, "length" inscrit le nouvel élément à la suite de la liste.<br />
			<span class="ex">&lt;script&gt; var fruits = ["abricot", "banane", "cerise", "datte"];
				fruits[fruits.length] = "épine-vinette"; fruits[fruits.length] = "fraise"; fruits[fruits.length] =
				"groseille";
				document.write(fruits); &lt;/script&gt;</span>
			<span class="js">
				<script>
					var fruits = ["abricot", "banane", "cerise", "datte"];
					fruits[fruits.length] = "épine-vinette";
					fruits[fruits.length] = "fraise";
					fruits[fruits.length] = "groseille";
					document.write(fruits);
				</script>
			</span></div>

		<div>Pour imprimer les fruits en liste :
			<span class="ex">&lt;script&gt; var fruits = ["abricot", "banane", "cerise", "datte"], p = "";
				for(var i = 0; i < fruits.length; i++) {p +=" Fruit n°" + (i + 1) + " : " + fruits[i];};
					document.write(p); &lt;/script&gt; </span> <span class="js">
					<script>
						var fruits = ["abricot", "banane", "cerise", "datte"],
							p = "";
						for (var i = 0; i < fruits.length; i++) {
							p += " Fruit n°" + (i + 1) + " : " + fruits[i];
						};
						document.write(p);
					</script></span>
		</div>

		<h3>L'objet Date</h3>
		<div>C'est un objet natif du JS qui permet de manipuler les dates. Les dates peuvent être écrites <ul>
				<li>sous forme de chaine</li>
				<li>sous forme d'un Timestamp Unix multiplié par 1000 : c'est le nombre de seconde écolées depuis le
					premier
					janvier
					1970 à minuit UTC (Universal Time). Le JS compte en ms, il faut donc multiplier le chiffre du
					Timestamp
					par 1000.<br /><span class="ex">&lt;script&gt; var d3 = new Date(604800000);
						document.write(d3); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var d3 = new Date(604800000);
							document.write(d3);
						</script>
					</span></li>
			</ul>
		</div>
		<div>L'objet Date() permet de récupérer la date actuelle : <br /><span class="ex">&lt;script&gt; var d = new
				Date();
				document.write(d); &lt;/script&gt;</span>
			<span class="js">
				<script>
					var d = new Date();
					document.write(d);
				</script>
			</span>
		</div>
		<div>On peut spécifier la date sous forme de nombres avec 7 nombres (seuls les 3 premiers sont obligatoires) :
			ATTENTION, le mois de janvier = 0<br /><span class="ex">&lt;script&gt; var d2 = new Date(2002, 7, 29, 15);
				document.write (d2) &lt;/script&gt; </span>
			<span class="js">
				<script>
					var d2 = new Date(2002, 7, 29, 15);
					document.write(d2)
				</script>
			</span>
		</div>
		<div>On peut spécifier la date sous forme de chaine, au format JS pour être reconnue. JS reconnait 4 grands
			types de
			format de dates :<ul>
				<li>date longue : <br /><span class="ex">&lt;script&gt; var d1 = new Date("August 5 2000 12:00:00");
						document.write
						(d1) &lt;/script&gt; </span>
					<span class="js">
						<script>
							var d1 = new Date("Aug 5 2000 12:00:00");
							document.write(d1)
						</script>
					</span></li>
				<li>date courte : <br /><span class="ex">&lt;script&gt; var d4 = new Date("10/3/1970"); document.write
						(d4)
						&lt;/script&gt; </span>
					<span class="js">
						<script>
							var d4 = new Date("10/3/1970");
							document.write(d4)
						</script>
					</span></li>
			</ul>
			<li>date complète : <br /><span class="ex">&lt;script&gt; var d5 = new Date("Sun Jan 25 2015 09:00:00
					GMT+0100");
					document.write (d5) &lt;/script&gt; </span>
				<span class="js">
					<script>
						var d5 = new Date("Sun Jan 25 2015 09:00:00 GMT+0100");
						document.write(d5)
					</script>
				</span></li>
			<li>date iso (recommandée) : <br /><span class="ex">&lt;script&gt; var d6 = new Date("1976-09-02");
					document.write
					(d6) &lt;/script&gt; </span>
				<span class="js">
					<script>
						var d6 = new Date("1976-09-02");
						document.write(d6)
					</script>
				</span></li>
		</div>
		<div>Il existe une cinquantaine de méthodes pour l'objet Date() réparties en 2 sous-ensembles :<ul>
				<li>les getters pour récupérer une information relative à une date : elles commencent par "get", par
					exemple
					:<ul>
						<li>getTime() renvoie le nombre de ms écoulées depuis le 1er janvier 1970<br /><span
								class="ex">&lt;script&gt; var
								d = new Date(); var dMs = d.getTime();
								document.write(dMs); &lt;/script&gt;</span>
							<span class="js">
								<script>
									var d = new Date();
									var dMs = d.getTime();
									document.write(dMs);
								</script>
							</span></li>
						<li>getDay() renvoie le jour de la semaine sous forme de nombre de 0 (= dimanche) à 6 (= samedi)
							:<br /><span class="ex">&lt;script&gt; var d = new Date(); var dday = d.getDay();
								document.write("Aujourd'hui, nous sommes
								");
								switch (dday) {
								case 0 : document.write("dimanche"); break;
								case 1 : document.write("lundi"); break;
								case 2 : document.write("mardi"); break;
								case 3 : document.write("mercredi"); break;
								case 4 : document.write("jeudi"); break;
								case 5 : document.write("vendredi"); break;
								case 6 : document.write("samedi"); break;
								default : document.write("c'est une colle!");
								} &lt;/script&gt;</span>
							<span class="js">
								<script>
									var d = new Date();
									var dday = d.getDay();
									document.write("Aujourd'hui, nous sommes ");
									switch (dday) {
										case 0:
											document.write("dimanche");
											break;
										case 1:
											document.write("lundi");
											break;
										case 2:
											document.write("mardi");
											break;
										case 3:
											document.write("mercredi");
											break;
										case 4:
											document.write("jeudi");
											break;
										case 5:
											document.write("vendredi");
											break;
										case 6:
											document.write("samedi");
											break;
										default:
											document.write("c'est une colle!");
									}
								</script>
							</span></li>
						<li>mais aussi <span class="ex">getFullYear()</span> qui renvoie l'année; <span
								class="ex">getMonth()</span> qui
							renvoie le mois; <span class="ex">getDate()</span> qui renvoie le jour du mois</li>
					</ul>
				</li><br />
				<li>les setters pour définir une date : elles commencent par "set". On va retrouver souvent les même que
					pour "get".
					<br />Un exemple de "set" avec la méthode setInterval() appelle une fonction ou évalue une
					expression
					dans un laps
					de temps spécifié (en ms), jusqu'à ce que la fonction clearInterval() soit appelée ou la fenêtre
					fermée.<br />
					<span class="ex">&lt;script&gt; var counter = 10; var intervalId = null; function finish()
						{clearInterval(intervalId); document.getElementById("bip").innerHTML = "Terminé!";} function
						bip()
						{counter--;
						if(counter == 0) finish();
						else {document.getElementById("bip").innerHTML = counter + " secondes restantes";}}
						function start() {intervalId = setInterval(bip, 1000);} &lt;/script&gt;</span>
					<span class="js">
						<button onclick="start()">Lancer le décompte</button>
						<div id="bip" class="display"></div>
						<script>
							var counter = 10;
							var intervalId = null;

							function finish() {
								clearInterval(intervalId);
								document.getElementById("bip").innerHTML = "Terminé!";
							}

							function bip() {
								counter--;
								if (counter == 0) finish();
								else {
									document.getElementById("bip").innerHTML = counter + " secondes restantes";
								}
							}

							function start() {
								intervalId = setInterval(bip, 1000);
							}
						</script>
					</span></li>
			</ul>
		</div>
		<div>La propriété innerHTML montre le contenu HTML d'un élément. La voici dans un programme qui envoie une
			horloge.<br />
			<span class="ex">&lt;script&gt;
				function printTime() {var d = new Date(); var hours = d.getHours(); var mins = d.getMinutes(); var secs
				=
				d.getSeconds(); var demo = document.getElementById("horloge");
				demo.innerHTML = hours+":"+mins+":"+secs;
				} setInterval (printTime, 1000); &lt;/script&gt;</span>
			<script>
				function printTime() {
					var d = new Date();
					var hours = d.getHours();
					var mins = d.getMinutes();
					var secs = d.getSeconds();
					var demo = document.getElementById("horloge");
					demo.innerHTML = hours + ":" + mins + ":" + secs;
				}
				setInterval(printTime, 1000);
			</script>
			<span id="horloge" class="js">Script à copier et coller ici</span>
		</div>
		<div>Pour mettre une date au format français, on peut utiliser les tableaux : <br /><span
				class="ex">&lt;script&gt;
				var d = new Date();
				var dy = d.getFullYear();
				var dmo = d.getMonth();
				var dday = d.getDay();
				var ddate = d.getDate();
				var dh = d.getHours();
				var dmi = d.getMinutes();
				var ds = d.getSeconds();
				var mois = ["janvier", "février", "mars", "avril", "mai", "juin", "juillet", "août", "septembre",
				"octobre",
				"novembre", "décembre"];
				var jour = ["dimanche", "lundi", "mardi", "mercredi", "jeudi", "vendredi", "samedi"];
				document.write("Aujourd'hui, " +jour[dday]+ " " +ddate+ " " +mois[dmo]+ " " +dy+ ", il est " +dh+ "h "
				+dmi+
				"mn et
				" + ds + "s."); &lt;/script&gt;</span>
			<span class="js">
				<script>
					var d = new Date();
					var dy = d.getFullYear();
					var dmo = d.getMonth();
					var dday = d.getDay();
					var ddate = d.getDate();
					var dh = d.getHours();
					var dmi = d.getMinutes();
					var ds = d.getSeconds();
					var mois = ["janvier", "février", "mars", "avril", "mai", "juin", "juillet", "août", "septembre", "octobre",
						"novembre", "décembre"
					];
					var jour = ["dimanche", "lundi", "mardi", "mercredi", "jeudi", "vendredi", "samedi"];
					document.write("Aujourd'hui, " + jour[dday] + " " + ddate + " " + mois[dmo] + " " + dy + ", il est " + dh + "h " +
						dmi + "mn et " + ds + "s.");
				</script>
			</span>
		</div><br />
		<div>Les setters vont permettre également de créer des animations.</div>
		<div id="grand">
			<div id="petit"></div>
		</div>
		<div>
			<br /><span class="ex">&lt;script&gt; var t = setInterval(move, 10);
				var pos = 0; /*position de départ*/
				var box = document.getElementById("petit");
				var t = setInterval(move, 10);
				function move() {if (pos >= 150) {clearInterval(t);} else {pos += 1; box.style.left = pos+"px";}};
				&lt;/script&gt;</span>
			<span class="js">
				<script>
					var pos = 0; /*position de départ*/
					var box = document.getElementById("petit");
					var t = setInterval(move, 20);

					function move() {
						if (pos >= 150) {
							clearInterval(t);
						} else {
							pos += 1;
							box.style.left = pos + "px";
						}
					};
				</script>
			</span>
		</div>
		<h3>L'objet Math</h3>
		<div>Il ne possède pas de constructeur donc on ne peut pas créer d'objet de type math, mais seulement utiliser
			celui-ci. Il permet de réaliser des tâches mathématiques et comprend différentes propriétés : E, LN2, LN10,
			LOG2E,
			LOG10E, PI.<br /><span class="ex">&lt;script&gt; document.write(Math.PI); &lt;/script&gt;</span>
			<span class="js">
				<script>
					document.write(Math.PI);
				</script>
			</span>
		</div>
		<div>Il comprend aussi des méthodes utilisées pour les calculs. Par exemple, random() renvoie un nombre entre 0
			et 1
			:
			<span class="ex">&lt;script&gt; var x = Math.random(); var y = Math.random();
				document.write("x = " + x + "et son arrondi y = " + y); &lt;/script&gt;</span>
			<span class="js">
				<script>
					var x = Math.random();
					var y = Math.random();
					document.write("x = " + x + "et y = " + y);
				</script>
			</span>
		</div>
		<div>La méthode round() renvoie un nombre entier : <span class="ex">&lt;script&gt; var x = Math.random()*100;
				var y
				=
				Math.round(x);
				document.write("x = " + x + " et y = " + y); &lt;/script&gt;</span>
			<span class="js">
				<script>
					var x = Math.random() * 100;
					var y = Math.round(x);
					document.write("x = " + x + " et y = " + y);
				</script>
			</span>
		</div>
		<div>Les méthodes floor() et ceil() permet d'arrondir un nombre décimal à l'entier au dessous ou au dessus :
			<span class="ex">&lt;script&gt; var x = Math.random()*100; var y = Math.floor(x); var z = Math.ceil(x);
				document.write("x = " + x + " ; arrondi au-dessous = " + y + " et arrondi au-dessus = " = z);
				&lt;/script&gt;</span>
			<span class="js">
				<script>
					var x = Math.random() * 100;
					var y = Math.floor(x);
					var z = Math.ceil(x);
					document.write("x = " + x + " ; arrondi au-dessous = " + y + " et arrondi au-dessus = " + z);
				</script>
			</span>
		</div>
		<div>La méthode sqrt() renvoie la racine carré d'un nombre : <span class="ex">&lt;script&gt; var x =
				Math.random()*100; var y = Math.round(x); var z = Math.sqrt(y);
				document.write("y = " + y + " et sa racine carré = " + z); &lt;/script&gt;</span>
			<span class="js">
				<script>
					var x = Math.random() * 100;
					var y = Math.round(x);
					var z = Math.sqrt(y);
					document.write("y = " + y + " et sa racine carré = " + z);
				</script>
			</span>
		</div>
		<hr />
		<h2 id="ledom">Le DOM : Document Object Model</h2>
		<p>C'est une interface qui permet de manipuler du code HTML dynamiquement en utilisant le JS. Le DOM comprend 3
			parties : une pour le XML, une pour le HTML, une partie "coeur" accessible pour tous.
		</p>
		<div>Quand on ouvre une page web, le HTML est chargé et rendu visible sur l'écran. Pour faire cela, le
			navigateur
			construit le DOM, qui est un modèle orienté objet dans sa structure logique. Le document peut être
			représenté
			comme
			un arbre, où &lt;html&gt; a 2 noeuds "enfants" : &lt;head&gt; et &lt;body&gt; ; &lt;head&gt; a un noeud
			"enfant"
			&lt;html&gt; et un "parent" &lt;html&gt; ... Ces "noeuds" ou éléments vont être traités, grâce à l'objet
			<span class="ex">Element</span>.</div>
		<img src="../Images/DOM.jpg" height="48%" width="48%" alt="" />
		<p>L'objet <span class="ex">document</span> prédéfini en JS, est propriétaire de tous les objets de la page.</p>
		<p>Les objets document et element vont permettre d'accéder et de modifier une page HTML et le code CSS associé.
		</p>
		<p>Par exemple, <span class="ex">document.body.innerHTML = "où est passé mon site ?";</span> va remplacer
			l'ensemble
			de la page grâce à la propriété innerHTML (innerHTML est une propriété de l'objet element)</p>
		<div>L'<strong>objet document</strong> a des propriétés et des méthodes propres, dont 3 couramment utilisées
			pour
			sélectionner des éléments HTML :<ul>
				<li><span class="ex">document.getElementById(id)</span> pour trouver un élément par son id. Par exemple
					:
					pour
					renvoyer le nom de l'objet<br />

					<span class="ex">&lt;script&gt; var tag = document.getElementById("ledom");
						document.write(tag); &lt;/script&gt;</span><br />
					<span class="js">
						<script>
							var tag = document.getElementById("ledom");
							document.write(tag);
						</script>
					</span> <br /> ou renvoyer le contenu de l'objet :
					<span class="ex">&lt;script&gt; var tag1 = document.getElementById("ledom").textContent;
						document.write(tag1); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var tag1 = document.getElementById("ledom").textContent;
							document.write(tag1);
						</script>
					</span>
				</li>
				<hr />
				<li>
					<h3>Rajouter un décompte de temps pour inciter à répondre rapidement à une question</h3><span
						class="ex">document.getElementsByClassName("name")</span>
					permet de trouver des éléments par le nom de leur classe. Cette methode renvoie une collection de
					tous
					les éléments
					du document qui ont spécifiquement ce nom de classe comme une liste de noeuds (NodeList object).
				</li>
				<div class="QuestionText"><span class="js">Quelle est votre quête ?</span></div>


				<br /><span class="ex">&lt;script&gt;
					function MyfunctionCounter(){//crée la fonction compteur
					var counter = 5; //met le compteur à 5 <br />
					var intervalId = null; //met l'interval à 0<br />
					var div = document.createElement("div");//créé un élément div<br />
					div.setAttribute("id", "alert1");// attribut un id="alert1" à la div<br />
					var text = document.createTextNode("- ");//va créer un nouveau texte vide<br />
					div.appendChild(text); //attribue le texte à div<br />
					var z = document.getElementsByClassName("QuestionText"); //va chercher les élements avec la classe
					concernée et en
					fait une liste (ou un tableau)<br />
					z[0].appendChild(div);//designe div comme enfant de la première div "QuestionText"<br />
					function finish() {<br />
					clearInterval(intervalId); // arrete le compteur (setInterval)<br />
					document.getElementById("alert1").innerHTML = "MERCI DE REPONDRE MAINTENANT"; //affiche
					l'alerte<br />
					document.getElementById("alert1").style.backgroundColor = "red"; //colore l'alerte
					}<br />
					function bip() {counter--; if(counter == 0) finish(); //compteur<br />
					else {document.getElementById("alert1").innerHTML = "Il vous reste " +counter + " seconde(s) pour
					répondre.";}} <br />
					function start() {intervalId = setInterval(bip, 1000);} //lance la fonction bip, qui s'execute
					toutes
					les secondes<br />
					start();// lance la fonction start}<br />
					MyfunctionCounter();//lance le compteur<br />
					&lt;/script&gt;</span>
				<span class="js">
					<script>
						function MyfunctionCounter() {
							var counter = 5; //met le compteur à 5
							var intervalId = null; //met l'interval à 0

							var div = document.createElement("div"); //créé un élément div
							div.setAttribute("id", "alert1"); // attribut un id="alert1" à la div

							var text = document.createTextNode("- "); //va créer un nouveau texte vide
							div.appendChild(text); //attribue le texte à div
							var z = document.getElementsByClassName(
								"QuestionText"); //va chercher les élements avec la classe concernée et en fait une liste (ou un tableau)
							z[0].appendChild(div); //designe div comme enfant de la première div "QuestionText"


							function finish() {
								clearInterval(intervalId); // arrete le compteur (setInterval)
								document.getElementById("alert1").innerHTML = "MERCI DE REPONDRE MAINTENANT"; //affiche l'alerte
								document.getElementById("alert1").style.backgroundColor = "red"; //colore l'alerte
							}

							function bip() {
								counter--;
								if (counter == 0) finish(); //compteur
								else {
									document.getElementById("alert1").innerHTML = "Il vous reste " + counter +
										" seconde(s) pour répondre.";
								}
							}

							function start() {
								intervalId = setInterval(bip, 1000);
							} //lance la fonction bip, qui s'execute toutes les secondes

							start();
						}
						MyfunctionCounter();
					</script>
				</span>
				<hr />
				<li><span class="ex">document.getElementsByTagName("name")</span> pour trouver un élément par une
					balise, va
					renvoyer un tableau avec l'ensemble des éléments cottespondants</li>
			</ul> et d'autres utilisées pour sélectionner des éléments par leurs sélecteurs CSS class ou id :<ul>
				<li><span class="ex">querySelector()</span> va renvoyer des informations relatives au premier élément
					trouvé
					correspondant au selecteur CSS sélectionné. En voici quelques exemples : <br />
					<span class="ex">&lt;script&gt; var lien = document.querySelector("span a"); document.write(lien);
						&lt;/script&gt;</span>
					<span class="js">
						<script>
							var lien = document.querySelector("span a");
							document.write(lien);
						</script>
					</span><br />

					<span class="ex">&lt;script&gt; var lien = document.querySelector("span a").textContent;
						document.write(lien);
						&lt;/script&gt;</span>
					<span class="js">
						<script>
							var lien = document.querySelector("span a").textContent;
							document.write(lien);
						</script>
					</span><br />

					<span class="ex">&lt;script&gt; var lien = document.querySelector("span a").innerHTML;
						document.write(lien); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var lien = document.querySelector("span a").innerHTML;
							document.write(lien);
						</script>
					</span><br />

					<span class="ex">&lt;script&gt; var lien = document.querySelector(".para");
						document.write(lien); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var lien = document.querySelector(".para");
							document.write(lien);
						</script>
					</span><br />

					<span class="ex">&lt;script&gt; var lien = document.querySelector(".para").textContent;
						document.write(lien); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var lien = document.querySelector(".para").textContent;
							document.write(lien);
						</script>
					</span><br />

					<span class="ex">&lt;script&gt; var lien = document.querySelector(".para").innerHTML;
						document.write(lien); &lt;/script&gt;</span>
					<span class="js">
						<script>
							var lien = document.querySelector(".para").innerHTML;
							document.write(lien);
						</script>
					</span><br /><br />
				</li>
				<li><span class="ex">querySelectorAll()</span> va renvoyer des informations sur tous les éléments
					correspondants</li>
			</ul>On peut ainsi accéder à tout type d'éléments : avec link, on peut voir tous les éléments area et a qui
			contiennent un attribut href.
		</div>
		<div>Chaque élément du DOM a ses propres propriétés et méthodes qui fournissent leur relations avec le DOM :<ul>
				<li>element.childNodes : renvoie un tableau des enfants des noeuds.</li>
				<li>element.firstChild : renvoie le premier enfant du noeud d'un élément.</li>
				<li>element.lastChild : renvoie le dernier enfant du noeud d'un élément.</li>
				<li>element.hasChildNodes : renvoie vrai si un élément a un noeud enfant, sinon faux.</li>
				<li>element.nextSibling : renvoie le prochain noeud du même niveau de l'arbre.</li>
				<li>element.previousSibling : renvoie le précédent du même niveau de l'arbre.</li>
				<li>element.parentNode : renvoie le noeud parent d'un élément.</li>
			</ul>
		</div>
		<div>On peut <strong>créer de nouveaux éléments</strong> avec : <ul>
				<li>element.cloneNode() : duplique un élément et renvoie le résultat au noeud.</li>
				<li>document.createElement(element) : crée un nouveau noeud</li>
				<li>document.createTextNode() : créé un nouveau noeud texte. Par exemple :</li>
			</ul>
		</div>

		<div id="ajout" class="js">Ici une div où ajouter un texte : </div>
		<div><br /><span class="ex">&lt;script&gt;
				var p = document.createElement("p"); /*va créer un nouveau paragraphe*/
				var noeud = document.createTextNode("Voici mon nouveau texte"); /*va créer un nouveau texte*/
				p.appendChild(noeud);
				var div = document.getElementById("ajout"); /*ajoute le paragraphe à la div*/
				div.appendChild(p); &lt;/script&gt;</span>
			<span class="js">
				<script>
					var p = document.createElement("p"); /*va créer un nouveau paragraphe*/
					var noeud = document.createTextNode(
					"Voici mon nouveau texte (le script est après)."); /*va créer un nouveau texte*/
					p.appendChild(noeud); /*met le texte dans p*/
					var div = document.getElementById("ajout"); /*ajoute le paragraphe à la div*/
					div.appendChild(p);
				</script>
		</div>
		<hr />
		<div><strong>Attribuer un élément à un autre</strong> avec <span class="ex">appendChild()</span>(Exercice 5)
		</div>
		<script type="text/javascript">
			var x = 0;

			function verse() {
				var water = document.getElementById('water');
				var glass = document.getElementById('glass');
				glass.appendChild(water);
				x++;
				switch (x) {
					case 1:
						water.style.marginTop = "100px";
						water.style.height = "20px";
						break;
					case 2:
						water.style.marginTop = "80px";
						water.style.height = "40px";
						break;
					case 3:
						water.style.marginTop = "60px";
						water.style.height = "60px";
						break;
					case 4:
						water.style.marginTop = "40px";
						water.style.height = "80px";
						break;
					case 5:
						water.style.marginTop = "20px";
						water.style.height = "100px";
						break;
					case 6:
						water.style.marginTop = "0px";
						water.style.height = "120px";
						break;
					default:
						document.write("c'est plein !");

				};
			}
		</script>
		<div class="container">
			<div id="water" class="water">
				Water
			</div>
			<div id="glass" class="glass"></div>
			<div class="clear"></div>
		</div>


		<div class="container">Cliquez sur le bouton pour mettre l'eau dans le verre&nbsp;:
			<button onclick="verse()">
				Verser
			</button>
		</div>
		<span class="ex">&lt;script&gt;
			var x = 0;<br />

			function verse() {<br />
			var water = document.getElementById('water');<br />
			var glass = document.getElementById('glass');<br />
			glass.appendChild(water);<br />
			x++;<br />
			switch (x) {<br />
			case 1:
			water.style.marginTop = "100px";
			water.style.height = "20px";
			break;<br />
			case 2:
			water.style.marginTop = "80px";
			water.style.height = "40px";
			break;<br />
			case 3:
			water.style.marginTop = "60px";
			water.style.height = "60px";
			break;<br />
			case 4:
			water.style.marginTop = "40px";
			water.style.height = "80px";
			break;<br />
			case 5:
			water.style.marginTop = "20px";
			water.style.height = "100px";
			break;<br />
			case 6:
			water.style.marginTop = "0px";
			water.style.height = "120px";
			break;<br />
			default : document.write("c'est plein !");

			};}<br />
			&lt;/script&gt;</span>
		<hr />
		<div>On peut <strong>retirer un élément HTML</strong> avec la méthode <span class="ex">removeChild(node)</span>
			:
		</div>

		<div id="retrait" class="js"> Voici une div avec 2 paragraphes :
			<p id=p1>Ceci est le premier paragraphe.</p>
			<p id=p2>Ceci est le second paragraphe.</p>
		</div>
		<div><span class="ex">&lt;script&gt; var parent = document.getElementById("retrait");
				var enfant = document.getElementById("p1");
				parent.removeChild(enfant); &lt;/script&gt;</span>
			<span class="js">
				<script>
					var parent = document.getElementById("retrait");
					var enfant = document.getElementById("p1");
					parent.removeChild(enfant);
				</script>
			</span>
		</div><br />

		<div>Enfin, on peut <strong>remplacer un élément</strong> avec <span class="ex">element.replaceChild(nouveau
				Noeud,
				vieuxnoeud) : </span></div>
		<div id="remplace" class="js">Voici la div dans laquelle on va remplacer un élément : <p id="p3">le paragraphe à
				remplacer.</p>
		</div>
		<div><br /><span class="ex">&lt;script&gt; var p = document.createElement("p");
				var noeud = document.createTextNode("Voici le nouveau paragraphe");
				p.appendChild(noeud);
				var parent = document.getElementById("remplace");
				var child = document.getElementById("p3");
				parent.replaceChild(p, child); &lt;/script&gt;</span>
			<span class="js">
				<script>
					var p = document.createElement("p");
					var noeud = document.createTextNode("Voici le nouveau paragraphe");
					p.appendChild(noeud);
					var parent = document.getElementById("remplace");
					var child = document.getElementById("p3");
					parent.replaceChild(p, child);
				</script>
			</span></div>
		<hr />
		<h2>Les événements en JavaScript</h2>
		<p>Ils correspondent à des actions utilisées effectuées par l'utilisateur (par exemple, cliquer sur un bouton)
			ou le
			navigateur (par exemple, finir de charger une page). Pour attacher une action à un événement, on va utiliser
			des
			attributs HTML de type événement et créer en JS le code correspondant à l'action.</p>
		<div>Les attributs HTML de type événement sont nombreux : <ul>
				<li>l'attribut <span class="ex">onclick</span> se déclenche quand on clique sur l'élément<span
						onclick="alert('bravo !');" class="js"><br />Cliquez ici !</span> (= on peut mettre du JS
					directement en valeur de l'attribut onclick)</li>
				<li>l'attribut <span class="ex">onmouseover</span> se déclenche quand on passe le curseur de la souris
					sur
					l'élément</li>
				<li>l'attribut <span class="ex">onmouseout</span> se déclenche quand on sort le curseur de l'élément
				</li>
				<li>l'attribut <span class="ex">onkeydown</span> se déclenche quand on appuie sur une touche sans
					relacher
					avec son
					curseur sur l'élément</li>
				<li>l'attribut <span class="ex">onload</span> arrive quand une page a été chargée. L'évènement <span
						class="ex">window.onload</span>
					peut aussi ête utilisé pour dérouler un code quand la page est chargée</li>
				<li>l'attribut <span class="ex">onunload</span> arrive une fois que la page a été quittée</li>
				<li>l'attribut <span class="ex">onchange</span> se déclenche quand le contenu d'un élément form, ou le
					selecteur ou
					la vérification ont changé. Il est souvent utilisé pour les zones de texte
					<input type="text" id="name" onchange="change()">
					<script>
						function change() {
							var x = document.getElementById("name");
							x.value = x.value.toUpperCase();
						}
					</script>
				</li>
				<li>l'attribut <span class="ex">onmousedown</span> se déclenche quand l'utilisateur clique un élément
				</li>
				<li>l'attribut <span class="ex">onmousedown</span> se déclenche quand l'utilisateur appuie le bouton de
					souris sur
					un élément</li>
				<li>l'attribut <span class="ex">onmouseup</span> se déclenche quand l'utilisateur relache le bouton de
					souris sur un
					élément</li>
				<li>l'attribut <span class="ex">onblur</span> se déclenche quand un élément n'est plus au centre le
					centre
				</li>
				<li>l'attribut <span class="ex">onfocus</span> se déclenche quand un élément devient le centre</li>
			</ul>
		</div>
		<div>Le mot clé "this" va faire référence à l'objet qui est le sujet de l'évenement. Dans l'exemple ci-dessus,
			il
			peut
			aider à changer un contenu, car fait référence à l'élément "span" qui le contient.<br />
			<span onclick="this.textContent='Merci !';" class="js">Cliquez ici !</span></div>
		<h3>La méthode addEventListener</h3>
		<div>Le DOM HTML va permettre d'assigner des gestionnaires d'évènements spécifiques à des éléments HTML en
			utilisant
			la méthode <span class="ex">addEventListener()</span>. Elle appartient à l'objet élément et elle a besoin de
			2
			arguments pour fonctionner : <ul>
				<li>le nom de l'évènement déclencheur de l'action, comme "click", "mousedown", "mouseover"...(dans ce
					cas,
					on omet
					le préfixe "on")</li>
				<li>le code de l'action à utiliser.</li>
			</ul>On peut associer plusieurs actions à un même élément.</div>
		<span id="test" class="js">TEST</span>
		<br /><span class="ex">&lt;script&gt;
			var p4 = document.getElementById("test");
			p4.addEventListener("mouseover",fonction1);
			p4.addEventListener("mouseout",reset1);
			p4.addEventListener("mousedown",fonction2);
			p4.addEventListener("mouseup",reset2);
			function fonction1() {
			this.innerHTML = "Cliquez-moi !";
			this.style.backgroundColor = "orange";
			};
			function reset1() {
			this.innerHTML = "TEST";
			this.style.backgroundColor = "";
			};
			function fonction2() {
			this.innerHTML = "Bravo !";
			this.style.backgroundColor = "yellow";
			};
			function reset2() {
			this.innerHTML = "TEST";
			this.style.backgroundColor = "";
			}; &lt;/script&gt;</span>
		<script>
			var p4 = document.getElementById("test");
			p4.addEventListener("mouseover", fonction1);
			p4.addEventListener("mouseout", reset1);
			p4.addEventListener("mousedown", fonction2);
			p4.addEventListener("mouseup", reset2);

			function fonction1() {
				this.innerHTML = "Cliquez-moi !";
				this.style.backgroundColor = "orange";
			};

			function reset1() {
				this.innerHTML = "TEST";
				this.style.backgroundColor = "";
			};

			function fonction2() {
				this.innerHTML = "Bravo !";
				this.style.backgroundColor = "yellow";
			};

			function reset2() {
				this.innerHTML = "TEST";
				this.style.backgroundColor = "";
			};
		</script>
		<p>La méthode element.removeEventListener() permet d'enlever des actions.</p>
		<p>ATTENTION, Internet explorer 8 et antérieur ne supportent pas ces méthodes. Il faut utiliser la méthode
			<strong>document.attachEvent()</strong>
			à la place.</p>

		<h3>La propagation des évènements</h3>
		<p>Un évènement va toujours partir de la racine de l'arbre DOM, cad de l'élément HTML vers l'élément le plus
			profond
			comportant le gestionnaire de cet évènement. Cette descente est appelée <strong>"phase de capture"
				(capturing :
				down)</strong>.
			Quand l'élément est atteint, il fait le chemin inverse et remonte jusquà à l'élément HTML : c'est la
			<strong>"phase
				de bouillonnement" (bubbling : up)</strong></strong>.</p>
		<p>C'est pendant la phase de bouillonement que, par défaut, se déclenche les évènements, comme dans l'exemple
			suivant
			(p est activé avant div)</p>
		<div id="div1" class="js">Voici une div pour contenir un paragraphe
			<p id="p4">Voici le paragraphe : cliquez ici</p>
		</div>
		<br /><span class="ex">&lt;script&gt; var div1 = document.getElementById("div1");
			var p4 = document.getElementById("p4");
			div1.addEventListener("click",MessageDiv);
			p4.addEventListener("click",MessageP);
			function MessageDiv() {alert("Evenement du div");};
			function MessageP() {alert("Evenement du paragraphe");}; &lt;/script&gt;</span>
		<span class="js">
			<script>
				var div1 = document.getElementById("div1");
				var p4 = document.getElementById("p4");
				div1.addEventListener("click", MessageDiv);
				p4.addEventListener("click", MessageP);

				function MessageDiv() {
					alert("Evenement du div");
				};

				function MessageP() {
					alert("Evenement du paragraphe");
				};
			</script>
		</span>
		<p>Le troisième paramètre optionnel de <span class="ex">addEventListener()</span> est un boléen qui permet de
			changer
			cet ordre. La valeur par défaut "false" déclanche les évènements lors de la remontée. La valeur "true"
			permet de
			déclencher les évènement lors de la phase de capture (descente)</p>
		<div id="div2" class="js">Voici une div pour contenir un paragraphe
			<p id="p5">Voici le paragraphe : cliquez ici</p>
		</div>
		<br /><span class="ex">&lt;script&gt; var div2 = document.getElementById("div2");
			var p5 = document.getElementById("p5");
			div2.addEventListener("click",MessageDiv,true);
			p5.addEventListener("click",MessageP,true);
			function MessageDiv() {alert("Evenement du div");};
			function MessageP() {alert("Evenement du paragraphe");}; &lt;/script&gt;</span>
		<span class="js">
			<script>
				var div2 = document.getElementById("div2");
				var p5 = document.getElementById("p5");
				div2.addEventListener("click", MessageDiv, true);
				p5.addEventListener("click", MessageP, true);

				function MessageDiv() {
					alert("Evenement du div");
				};

				function MessageP() {
					alert("Evenement du paragraphe");
				};
			</script>
		</span>
		<h3>L'objet Event</h3>
		<p>Il a des propriétés et des méthodes qui informent ou impactent le contexte de l'évenement déclenché. Il n'est
			accessible que pendant le déclenchement de l'évenement. il faut y accéder au sein de la fonction qui sert à
			exécuter
			l'action.</p>
		<p>La propriété <span class="ex">target</span> va retourner le type de l'élément qui a déclenché d'évènement ;
			alors
			que <span class="ex">current.target</span> retourne le type de l'élément portant le gestionnaire de
			l'évènement.
		</p>
		<div id="div3" class="js">Voici une div pour contenir un paragraphe
			<p id="p6">Voici le paragraphe : cliquez ici</p>
		</div>
		<br /><span class="ex">&lt;script&gt; var div2 = document.getElementById("div2");
			var p5 = document.getElementById("p5");
			div2.addEventListener("click",MessageDiv,true);
			p5.addEventListener("click",MessageP,true);
			function MessageDiv() {alert("Evenement du div");};
			function MessageP() {alert("Evenement du paragraphe");}; &lt;/script&gt;</span>
		<span class="js">
			<script>
				var div3 = document.getElementById("div3");
				var p6 = document.getElementById("p6");
				div3.addEventListener("click", Message);

				function Message(event) {
					this.innerHTML = "Elément déclencheur : " + event.target + "<br/>Elément portant l'évènement : " + event
						.currentTarget;
				}
			</script>
		</span>
		<p>La propriété <span class="ex">type</span> va retourner le type d'évènement qui a été déclenché.</p>
		<p>La propagation d'un évènement peut être arrêtée avec la méthode <span class="ex">stopPropagation()</span>.
		</p>
		<p>La méthode <span class="ex">preventDefault()</span>va empêcher l'évènement (si l'événement le permet), mais
			n'empèche pas la propagation.</p>
		<p>Ces deux méthodes peuvent être utilisées pour bloquer un formulaire mal rempli.</p>

		<p>L'évènement <span class="ex">onsubmit</span> sert à valider des formulaires (l'information ne sera pas
			envoyée si
			onsubmit renvoie "false").</p>
		<form onsubmit="return validate()" method="post">
			Entrez un nombre :<input type="text" name="num1" id="num1" /><br />
			Répétez le nombre :<input type="text" name="num2" id="num2" /><br />
			<input type="submit" value="submit" />
		</form>
		<script>
			function validate() {
				var n1 = document.getElementById("num1");
				var n2 = document.getElementById("num2");
				if (n1.value != "" && n2.value != "") /*si les deux sont pas vides*/ {
					if (n1.value == n2.value) {
						return true;
					}
				}
				alert("les valeurs ne sont pas égales");
				return false;
			}
		</script>
		<hr />
		<h3>Créer un slider d'images (à intégrer dans illustrations)</h3>
		<div>
			<button onclick="prev()">Prev</button>
			<img id="slider" src="../Images/2.jpg" width="200px" height="100px" />
			<button onclick="next()">Next</button>
			<br /><span class="ex">&lt;script&gt;
				var images=["../Images/1.jpg","../Images/2.jpg","../Images/3.jpg"];
				var num = 0;
				function next() {
				var slider = document.getElementById("slider");
				num++;
				if(num>=images.length) {num = 0;}
				slider.src = images[num];
				}
				function prev() {
				var slider = document.getElementById("slider");
				num--;
				if(num &lt; 0) {num=images.length-1;} slider.src=images[num]; } &lt;/script&gt; </span>
			<script>
				var images = ["../Images/1.jpg", "../Images/2.jpg", "../Images/3.jpg"];
				var num = 0;

				function next() {
					var slider = document.getElementById("slider");
					num++;
					if (num >= images.length) {
						num = 0;
					}
					slider.src = images[num];
				}

				function prev() {
					var slider = document.getElementById("slider");
					num--;
					if (num <
						0) {
						num = images.length - 1;
					}
					slider.src = images[num];
				}
			</script>
		</div>
		<hr />
		<h2>Le BOM : Browser Object Model</h2>
		<p>Il permet d'accéder au navigateur et notamment à la fenêtre ouverte actuellement. Contrairement au DOM, il
			n'existe pas de standard officiel, mais les navigateurs supportent à peu près les mêmes opérations,
			propriétés
			et
			objets, donc on peut effectuer les mêmes opérations.</p>
		<h3>L'objet window</h3>
		<p>C'est l'objet le plus célèbre : la fenêtre du navigateur. C'est un objet implicite, c'est-à-dire que la
			plupart
			du temps, on a pas besoin de le mentionner. Par exemple, <span class="ex">alert()</span> est un objet de
			window,
			mais on le le précise jamais dans la syntaxe. L'objet document est aussi une propriété de window.</p>
		<div>La méthode open() sert à ouvrir un nouvel onglet ou une nouvelle fenêtre. il peut prendre jusqu'à 4
			arguments
			: <ol>
				<li>l'url de destination</li>
				<li>l'endroit où s'ouvre la nouvelle page et il permet de donner un nom à la fenetre</li>
				<li>liste d'éléments pour caracériser la fenetre (largeur, hauteur, position...)</li>
				<li>booléen pour dire si la nouvelle fenetre remplace l'actuelle ou s'ajoute dans l'historique</li>
			</ol>
			<p class="BOM">Par exemple, cliquez ici pour lire un cours.</p>
			<span class="ex">&lt;script&gt; var bom = document.querySelector(".BOM");
				bom.addEventListener("click",fenetre);
				function fenetre()
				{window.open("https://www.pierre-giraud.com/javascript/cours-complet/javascript-bom-window.php","_blank",
				"width=500", "height=300");
				} &lt;/script&gt;</span>
			<span class="js">
				<script>
					var bom = document.querySelector("p.BOM");
					bom.addEventListener("click", fenetre);

					function fenetre() {
						window.open("https://www.pierre-giraud.com/javascript/cours-complet/javascript-bom-window.php", "_blank",
							"width=500", "height=300");
					}
				</script>
			</span>
		</div><br />
		<div>La méthode close() permet de fermer un onglet ou une fenetre, après certaines conditions remplies ou après
			l'exécution d'un certain code.</div>
		<div>La méthode resizeTo() permet de redimensionner une fenetre.</div>
		<h3>L'objet screen</h3>
		<p>Il donne accès à des informations concernant l'écran des utilisateurs (taille, resolution de l'écran...), ce
			qui
			permet d'adapter la page web pour un affichage optimisé.</p>
		<div>L'objet screen a 6 propriétés intéressantes : <ul>
				<li>width : retourne la largeur totale de l'écran</li>
				</li>
				<li>availWidth : retourne la largeur de l'écran mois celle de la barre des tâches</li>
				<li>height : retourne la hauteur de l'écran</li>
				<li>availHeight : retourne la hauteur de l'écran mois celle de la barre des tâches</li>
				<li>colorDepth : retourne la profondeur de la palette de couleur en bits</li>
				<li>pixelDepth : retourne la résolution de l'écran en bits par pixel</li>
				</li>
			</ul>
		</div>
		<p id="ecran" class="js">infos sur l'écran.</p>
		<div><span class="ex">&lt;script&gt; var hauteur = screen.height;
				var hauteurDispo = screen.availHeight;
				var largeur = screen.width;
				var largeurDispo = screen.availWidth;
				var reso = screen.pixelDepth;
				var couleur = screen.colorDepth;
				var ecran = document.getElementById("ecran");
				ecran.innerHTML =
				"Hauteur d'écran : "+ hauteur + " , dont " + hauteurDispo +
				" utile <br />Largeur d'écran : "+ largeur + " , dont " + largeurDispo +
				" utile <br />Palette de couleur : " + couleur +
				" bits <br />Résolution : " + reso + "bits/px";
				&lt;/script&gt;</span>
			<script>
				var hauteur = screen.height;
				var hauteurDispo = screen.availHeight;
				var largeur = screen.width;
				var largeurDispo = screen.availWidth;
				var reso = screen.pixelDepth;
				var couleur = screen.colorDepth;
				var ecran = document.getElementById("ecran");
				ecran.innerHTML =
					"Hauteur d'écran : " + hauteur + " , dont " + hauteurDispo +
					" utile <br/>Largeur d'écran : " + largeur + " , dont " + largeurDispo +
					" utile <br/>Palette de couleur : " + couleur +
					" bits <br/>Résolution : " + reso + "bits/px";
			</script>
		</div>
		<h3>L'objet navigator</h3>
		<p>Il va donner des information sur le navigateur et sur les préférences enregistrées (langues...). Mais ces
			données viennent de l'utilisateur et ne sont pas totalement fiables. on doit demander à l'utilisateur
			uneautorisation avant ce récupérer certaines données.</p>
		<div>L'objet navigator possède 10 propriétés : <ul>
				<li>language : retourne la langue définie dans le navigateur</li>
				<li>geolocalisation : retourne un objet géolocalisation, exploitable avec l'objet géolocalisation</li>
				<li>product : retourne le nom du moteur utilisé par le navigateur</li>
				<li>coockieEnabled : détermine si les coockies sont autorisés ou non</li>
				<li>appName : retourne le nom du navigateur</li>
				<li>appCodeName : retourne le nom de code du navigateur</li>
				<li>appVersion : retourne la version du navigateur</li>
				<li>online : détermine si le navigateur est en ligne ou pas</li>
				<li>platform : détermine pour quelle plateforme le navigateur est compilé</li>
				<li>userAgent : retourne l'entête du fichier user-agent envoyé par le navigateur du serveur</li>
			</ul>
		</div>
		<p id="navi" class="js">Infos sur le navigateur.</p>
		<div><span class="ex">&lt;script&gt;
				var langue = navigator.language;
				var navigateur = navigator.appName;
				var version = navigator.appVersion;
				var moteur = navigator.product;
				var coockie = navigator.coockieEnabled;
				var code = navigator.appCodeName;
				var navi = document.getElementById("navi");
				navi.innerHTML =
				"Langue : "+ langue +
				"<br />Navigateurn : "+ navigateur + ", Version : " + version + ", (" + code +
				")<br />Moteur : " + moteur +
				"<br />Autorisation des coockies : " + coockie ;
				&lt;/script&gt;</span>
			<script>
				var langue = navigator.language;
				var navigateur = navigator.appName;
				var version = navigator.appVersion;
				var moteur = navigator.product;
				var coockie = navigator.coockieEnabled;
				var code = navigator.appCodeName;
				var navi = document.getElementById("navi");
				navi.innerHTML = "Langue : " + langue + "<br/>Navigateur : " + navigateur + ", Version : " + version + ", (" +
					code + ") <br/>Moteur : " + moteur + "<br/>Autorisation des coockies : " + coockie;
			</script>
		</div>
		<p>La propriété <strong>geolocalisation</strong> va aider à localiser un visiteur, mais de façon plus complexe,
			car
			il renvoie un objet exploitable avec la méthode <span class="ex">getCurrentPosition()</span> de l'objet
			géolocalisation.</p>
		<p id="loca" class="js">localisation</p>
		<div><span class="ex">&lt;script&gt;
				var loca = document.getElementById("loca");
				var loc = navigator.geolocalisation;

				(function() {/*si on a accès à la localisation*/
				if(loc) {loc.getCurrentPosition(coordonnees);
				} /*sinon*/
				else {
				loca.innerHTML = "Localisation non disponible";
				}
				})();
				/*on récupère la position*/
				function coordonnees(x) {
				loca.innerHTML = "Latitude : "+ x.coords.latitude +
				"<br />Longitude : " + x.coords.longitude;
				}
			</span>
			<script>
				var loca = document.getElementById("loca");
				var loc = navigator.geolocalisation;
				(function () {
					/*si on a accès à la localisation*/
					if (loc) {
						loc.getCurrentPosition(coordonnees);
					} /*sinon*/
					else {
						loca.innerHTML = "Localisation non disponible";
					}
				})();
				/*on récupère la position*/
				function coordonnees(x) {
					loca.innerHTML = "Latitude : " + x.coords.latitude +
						"<br/>Longitude : " + x.coords.longitude;
				}
			</script>
		</div>

		<p>De plus Navigator possède la méthode javaEnabled() qui détermine si Java a été activé sur le navigateur ou
			pas
		</p>
		<h3>L'objet location</h3>
		<div>Il appartient à Window et fournit des informations sur l'URL de la page actuelle. Il possède 9 propriétés
			(assez peu utilisées) : </div>
		<div>Il possède aussi 3 méthodes : </div>
		<h3>L'objet history</h3>
		<p>Il appartient à l'objet Window. Il permet de se déplacer dans l'historique de navigation si l'utilisateur le
			permet. Il possède une propriété length qui indique le nombre d'url dans l'historique, et 3 méthodes</p>
		<hr />
		<h2>L'objet RegExp</h2>
		<div>Il permet un contrôle sur les chaînes de caractères, par exemple lorsque l'on vérifier un formulaire. On le
			surnomme regex pour "RegExp" ou "Regular Expression", ce qui se traduit par "expression rationnelle" (ou
			"expression régulière"). </div>
		<div>Il y a deux façon de créer une regex : <ul>
				<li>soit avec le mot clé "new" : <span class="ex">var maRegex = new RegExp("motif", "flags");</span>
				</li>
				<li>soit de façon moins lourde : <span class="ex">var maRegex = /motif/flags;</span></li>
			</ul>
		</div>
		<p>Le motif correspond à la chaine de caractère que l'on veut chercher.</p>
		<div>Le paramètre flags est facultatif et correspond à une option supplémentaire. Il y en a 3 : <ul>
				<li><strong>i</strong> = pour rechercher le motif sans tenir compte de la casse</li>
				<li><strong>g</strong> = signifie global, pour que la regex s'applique à toute la chaine</li>
				<li><strong>gi</strong> = pour combiner les deux.</li>
			</ul>
		</div>
		<div>Des symboles vont aider à formuler le motif : <ul>
				<li><strong>|</strong> signifie "ou"</li>
				<li><strong>.</strong> signifie "n'importe quel caractère"</li>
				<li><strong>^</strong> délimite le début de la chaîne</li>
				<li><strong>$</strong> délimite la fin de la chaîne</li>
				<li><strong>[]</strong> : les crochets permettent de définir une liste (= classe) de caractères</li>
				<li><strong>-</strong> : à l'intérieur des crochets, le tiret permet de définir une plage de valeurs
				</li>
				<li><strong>^</strong> placé à l'interieur des crochets indique les caractères que l'on ne doit pas
					trouver
				</li>
			</ul>
		</div>
		<p>Il existe des classes déjà définies :</p>
		<p>L'utilisation des regex consiste à chercher un motif (un ou plusieurs caractère) dans la chaîne de caractères
			:
			s'il le trouve, il renvoie "true", sinon "false".</p>
		<p>Voir aussi <a href="https://openclassrooms.com/fr/courses/146276-tout-sur-le-javascript/145569-lobjet-regexp"
				target="_blank">ici</a></p>

		<h2>Le JSON (JavaScript Object Notation)</h2>
		<p>C'est un format standard utilisé pour représenter des données structurées de façon semblable aux objets
			Javascript.
			Il est habituellement utilisé pour structurer et transmettre des données sur des sites web (par exemple,
			envoyer
			des
			données depuis un serveur vers un client afin de les afficher sur une page web ou vice versa). Comme cette
			notation
			est extrêmement courante, cet article a pour but de vous donner les connaissances nécessaires pour
			travailler
			avec le
			JSON en JavaScript, vous apprendre à analyser la syntaxe du JSON afin d'en extraire des données et écrire
			vos
			propres
			objets JSON.</p>
		<hr />
		<h2>Récapitulatif de la syntaxe</h2>

		<div>Créer une fonction, puis l'appeler<br />
			<span class="ex">
				document.write("exemple"); </span></div>

		<div>Appeler une fonction native<br />
			<span class="ex">
				document.write("exemple"); </span></div>

		<div>Créer une fonction anonyme, puis l'appeler<br />
			<span class="ex">
				document.write("exemple"); </span></div>

		<div>Créer une fonction auto-imbriquée<br />
			<span class="ex">
				document.write("exemple"); </span></div>

		<hr />
		<br />
		<hr /> à copier pour un autre exemple
		<br /><span class="ex">&lt;script&gt;<br />
			document.write("exemple"); &lt;/script&gt;</span><br />
		<span class="js">
			<script>
				document.write("exemple");
			</script>
		</span>
</body>

</html>